# $Id: user.py,v 1.69 2010/11/15 04:23:25 irees Exp $
import re
import os

import emen2.db.config
g = emen2.db.config.g()
from emen2.web.view import View



@View.register
class Patient(View):
	@View.add_matcher("^/patient/(?P<recid>[\w\- ]+)/$")
	def init(self, recid=None):
		self.template = "/test/patient"

		self.admin = self.db.checkadmin()
		self.recid = recid
		self.rec = self.db.getrecord(recid)
		rendered = self.db.renderview(self.rec, viewtype="defaultview", mode="htmledit")
		title = self.db.renderview(self.rec, viewtype="recname")

		events = self.db.getchildren(self.recid, rectype="medical_event*")
		events = self.db.getrecord(events)
		erendered = self.db.renderview(events, viewtype="recname")


		# .....
		qevents = [['children', 'recid', self.recid], ['rectype', '==', 'medical_event*']]
		self.ctxt["qevents"] = self.db.querytable(c=qevents)
		
		self.ctxt["erendered"] = erendered
		self.ctxt["rendered"] = rendered
		self.ctxt["admin"] = self.admin
		self.ctxt["edit"] = True
		self.ctxt["rec"] = self.rec
		self.ctxt["events"] = events
		self.title = title


